package com.zhentao.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhentao.domain.UserLogin;
import com.zhentao.dto.LoginDto;
import com.zhentao.service.UserLoginService;
import com.zhentao.mapper.UserLoginMapper;
import com.zhentao.utils.AppJwtUtil;
import com.zhentao.utils.SnowflakeIdGenerator;
import com.zhentao.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import redis.clients.jedis.Jedis;

import java.util.UUID;

/**
* @author 31810
* @description 针对表【user_login】的数据库操作Service实现
* @createDate 2025-05-10 09:55:27
*/
@Service
public class UserLoginServiceImpl extends ServiceImpl<UserLoginMapper, UserLogin>
    implements UserLoginService{
    @Autowired
    private UserLoginMapper userLoginMapper;
    @Override
    public ResultVo register(LoginDto loginDto) {
        UserLogin user=new UserLogin();
        user.setId(SnowflakeIdGenerator.getSnowId());
        if(StringUtils.isEmpty(loginDto.getUsername())){
            return ResultVo.ERROR();
        }
        if(StringUtils.isEmpty(loginDto.getPassword())){
            return ResultVo.ERROR();
        }
        user.setUsername(loginDto.getUsername());
        user.setPassword(loginDto.getPassword());
        int i = userLoginMapper.insert(user);
        return i>0?ResultVo.OK():ResultVo.ERROR();
    }

    @Override
    public ResultVo login(LoginDto loginDto) {
        if(StringUtils.isEmpty(loginDto.getUsername())){
            return ResultVo.ERROR();
        }
        if(StringUtils.isEmpty(loginDto.getPassword())){
            return ResultVo.ERROR();
        }
        QueryWrapper<UserLogin>queryWrapper=new QueryWrapper<>();
        queryWrapper.eq("username",loginDto.getUsername());
        UserLogin user = userLoginMapper.selectOne(queryWrapper);
        if(user==null){
            return ResultVo.ERROR();
        }
        if(user.getPassword().equals(loginDto.getPassword())){
            String token= AppJwtUtil.getToken(user.getId());
            Jedis jedis=new Jedis("localhost");
            jedis.set("token",token);
            jedis.close();
            return ResultVo.OK(token);
        }
        return ResultVo.ERROR();
    }
}




